diff --git a/flashchips.c b/flashchips.c
index 8059374..c6b9c49 100644
--- a/flashchips.c
+++ b/flashchips.c
@@ -13357,7 +13357,7 @@ const struct flashchip flashchips[] = {
 		.model_id	= GENERIC_DEVICE_ID,
 		.total_size	= 0,
 		.page_size	= 256,
-		.tested		= TEST_BAD_PREW,
+		.state		= STATE_BAD_PREW,
 		.probe		= probe_spi_rems,
 		.write		= NULL,
 	},
diff --git a/flashrom.c b/flashrom.c
index c20461a..0e4f8a7 100644
--- a/flashrom.c
+++ b/flashrom.c
@@ -1794,32 +1794,38 @@ void check_chip_supported(const struct flashchip *chip)
 			 "clone the contents of this chip (see man page for "
 			 "details).\n");
 	}
-	if (TEST_OK_MASK != (chip->tested & TEST_OK_MASK)) {
+	if ((chip->state.probe == BAD) || (chip->state.probe == NT) ||
+	    (chip->state.read == BAD)  || (chip->state.read == NT) ||
+	    (chip->state.erase == BAD) || (chip->state.erase == NT) ||
+	    (chip->state.write == BAD) || (chip->state.write == NT)){
 		msg_cinfo("===\n");
-		if (chip->tested & TEST_BAD_MASK) {
+		if ((chip->state.probe == BAD) ||
+		    (chip->state.read == BAD) ||
+		    (chip->state.erase == BAD) ||
+		    (chip->state.write == BAD)) {
 			msg_cinfo("This flash part has status NOT WORKING for operations:");
-			if (chip->tested & TEST_BAD_PROBE)
+			if (chip->state.probe == BAD)
 				msg_cinfo(" PROBE");
-			if (chip->tested & TEST_BAD_READ)
+			if (chip->state.read == BAD)
 				msg_cinfo(" READ");
-			if (chip->tested & TEST_BAD_ERASE)
+			if (chip->state.erase == BAD)
 				msg_cinfo(" ERASE");
-			if (chip->tested & TEST_BAD_WRITE)
+			if (chip->state.write == BAD)
 				msg_cinfo(" WRITE");
 			msg_cinfo("\n");
 		}
-		if ((!(chip->tested & TEST_BAD_PROBE) && !(chip->tested & TEST_OK_PROBE)) ||
-		    (!(chip->tested & TEST_BAD_READ) && !(chip->tested & TEST_OK_READ)) ||
-		    (!(chip->tested & TEST_BAD_ERASE) && !(chip->tested & TEST_OK_ERASE)) ||
-		    (!(chip->tested & TEST_BAD_WRITE) && !(chip->tested & TEST_OK_WRITE))) {
+		if ((chip->state.probe == NT) ||
+		    (chip->state.read == NT) ||
+		    (chip->state.erase == NT) ||
+		    (chip->state.write == NT)) {
 			msg_cinfo("This flash part has status UNTESTED for operations:");
-			if (!(chip->tested & TEST_BAD_PROBE) && !(chip->tested & TEST_OK_PROBE))
+			if (chip->state.probe == NT)
 				msg_cinfo(" PROBE");
-			if (!(chip->tested & TEST_BAD_READ) && !(chip->tested & TEST_OK_READ))
+			if (chip->state.read == NT)
 				msg_cinfo(" READ");
-			if (!(chip->tested & TEST_BAD_ERASE) && !(chip->tested & TEST_OK_ERASE))
+			if (chip->state.erase == NT)
 				msg_cinfo(" ERASE");
-			if (!(chip->tested & TEST_BAD_WRITE) && !(chip->tested & TEST_OK_WRITE))
+			if (chip->state.write == NT)
 				msg_cinfo(" WRITE");
 			msg_cinfo("\n");
 		}
@@ -1862,7 +1868,7 @@ int chip_safety_check(const struct flashctx *flash, int force, int read_it, int
 
 	if (read_it || erase_it || write_it || verify_it) {
 		/* Everything needs read. */
-		if (chip->tested & TEST_BAD_READ) {
+		if (chip->state.read == BAD) {
 			msg_cerr("Read is not working on this chip. ");
 			if (!force)
 				return 1;
@@ -1876,7 +1882,7 @@ int chip_safety_check(const struct flashctx *flash, int force, int read_it, int
 	}
 	if (erase_it || write_it) {
 		/* Write needs erase. */
-		if (chip->tested & TEST_BAD_ERASE) {
+		if (chip->state.erase == BAD) {
 			msg_cerr("Erase is not working on this chip. ");
 			if (!force)
 				return 1;
@@ -1889,7 +1895,7 @@ int chip_safety_check(const struct flashctx *flash, int force, int read_it, int
 		}
 	}
 	if (write_it) {
-		if (chip->tested & TEST_BAD_WRITE) {
+		if (chip->state.write == BAD) {
 			msg_cerr("Write is not working on this chip. ");
 			if (!force)
 				return 1;
diff --git a/ichspi.c b/ichspi.c
index 6c394db..3957266 100644
--- a/ichspi.c
+++ b/ichspi.c
@@ -1236,7 +1236,10 @@ static int ich_hwseq_probe(struct flashctx *flash)
 		msg_cdbg("In that range are %d erase blocks with %d B each.\n",
 			 size_high / erase_size_high, erase_size_high);
 	}
-	flash->chip->tested = TEST_OK_PREW;
+	flash->chip->state.probe = OK;
+	flash->chip->state.read = OK;
+	flash->chip->state.erase = OK;
+	flash->chip->state.write = OK;
 	return 1;
 }
 
diff --git a/print.c b/print.c
index 759908d..f411b3f 100644
--- a/print.c
+++ b/print.c
@@ -249,38 +249,46 @@ static int print_supported_chips(void)
 		for (i = curdevlen; i < maxchiplen; i++)
 			msg_ginfo(" ");
 
-		if ((chip->tested & TEST_OK_PROBE))
+		if (chip->state.probe == OK)
 			msg_ginfo("P");
+		else if (chip->state.probe == NA)
+			msg_ginfo("-");
 		else
 			msg_ginfo(" ");
-		if ((chip->tested & TEST_OK_READ))
+		if (chip->state.read == OK)
 			msg_ginfo("R");
+		else if (chip->state.read == NA)
+			msg_ginfo("-");
 		else
 			msg_ginfo(" ");
-		if ((chip->tested & TEST_OK_ERASE))
+		if (chip->state.erase == OK)
 			msg_ginfo("E");
+		else if (chip->state.erase == NA)
+			msg_ginfo("-");
 		else
 			msg_ginfo(" ");
-		if ((chip->tested & TEST_OK_WRITE))
+		if (chip->state.write == OK)
 			msg_ginfo("W");
+		else if (chip->state.write == NA)
+			msg_ginfo("-");
 		else
 			msg_ginfo(" ");
 		for (i = 0; i < border; i++)
 			msg_ginfo(" ");
 
-		if ((chip->tested & TEST_BAD_PROBE))
+		if (chip->state.probe == BAD)
 			msg_ginfo("P");
 		else
 			msg_ginfo(" ");
-		if ((chip->tested & TEST_BAD_READ))
+		if (chip->state.read == BAD)
 			msg_ginfo("R");
 		else
 			msg_ginfo(" ");
-		if ((chip->tested & TEST_BAD_ERASE))
+		if (chip->state.erase == BAD)
 			msg_ginfo("E");
 		else
 			msg_ginfo(" ");
-		if ((chip->tested & TEST_BAD_WRITE))
+		if (chip->state.write == BAD)
 			msg_ginfo("W");
 		else
 			msg_ginfo(" ");
diff --git a/print_wiki.c b/print_wiki.c
index 5dcc4b6..826f6a1 100644
--- a/print_wiki.c
+++ b/print_wiki.c
@@ -249,7 +249,6 @@ static void print_supported_boards_wiki(void)
 static void print_supported_chips_wiki(int cols)
 {
 	unsigned int lines_per_col;
-	uint32_t t;
 	char *s;
 	char vmax[6];
 	char vmin[6];
@@ -287,7 +286,35 @@ static void print_supported_chips_wiki(int cols)
 			c = !c;
 
 		old = f;
-		t = f->tested;
+		const char *probe, *read, *write, *erase;
+		switch (f->state.probe) {
+			case OK: probe = "OK"; break;
+			case BAD: probe = "No"; break;
+			case NA: probe = "NA"; break;
+			case DEP: probe = "Dep"; break;
+			default: probe = "?3"; break;
+		}
+		switch (f->state.read) {
+			case OK: read = "OK"; break;
+			case BAD: read = "No"; break;
+			case NA: read = "NA"; break;
+			case DEP: read = "Dep"; break;
+			default: read = "?3"; break;
+		}
+		switch (f->state.erase) {
+			case OK: erase = "OK"; break;
+			case BAD: erase = "No"; break;
+			case NA: erase = "NA"; break;
+			case DEP: erase = "Dep"; break;
+			default: erase = "?3"; break;
+		}
+		switch (f->state.write) {
+			case OK: write = "OK"; break;
+			case BAD: write = "No"; break;
+			case NA: write = "NA"; break;
+			case DEP: write = "Dep"; break;
+			default: write = "?3"; break;
+		}
 		s = flashbuses_to_text(f->bustype);
 		sprintf(vmin, "%0.03f", f->voltage.min / (double)1000);
 		sprintf(vmax, "%0.03f", f->voltage.max / (double)1000);
@@ -298,14 +325,7 @@ static void print_supported_chips_wiki(int cols)
 		       "|| %s || %s \n",
 		       (c == 1) ? "eeeeee" : "dddddd", f->vendor, f->name,
 		       f->total_size, s,
-		       (t & TEST_OK_PROBE) ? "OK" :
-		       (t & TEST_BAD_PROBE) ? "No" : "?3",
-		       (t & TEST_OK_READ) ? "OK" :
-		       (t & TEST_BAD_READ) ? "No" : "?3",
-		       (t & TEST_OK_ERASE) ? "OK" :
-		       (t & TEST_BAD_ERASE) ? "No" : "?3",
-		       (t & TEST_OK_WRITE) ? "OK" :
-		       (t & TEST_BAD_WRITE) ? "No" : "?3",
+		       probe, read, erase, write,
 		       f->voltage.min ? vmin : "N/A",
 		       f->voltage.min ? vmax : "N/A");
 		free(s);
-- 
Kind regards, Stefan Tauner

